/// <reference path="~/vsdocs/google-maps-3-vs-1-0.js" />
/// <reference path="gMapFunctions.js" />
/// <reference path="ahCore.js" />
/// <reference path="../map/radarSites.js" />

var ahLightningDownloadTime = new Date(0);
//create AllisonHouse Storm Report object (arrays will be stored within as properties)
var ahLightning = [];
var lightningIconImages;

$(function () {
    $(".ahLightningToggle").change(function (e) {
        checkReportDownloadTime(this.getAttribute("data-reporttype"), $(this), ahLightningDownloadTime, toggleLightning, downloadAHLightning);
    });
});



function downloadAHLightning() {
    waitForIt();
    console.log("Starting fetch of AH Reports...");
    ahLightningDownloadTime = new Date(); //record our time
    var reportCounter = 0;
    ahLightning = [];
    if (!lightningIconImages) {
        lightningIconImages = [];
        for (var index = 0; index < 16; index++) {
            lightningIconImages.push(new google.maps.MarkerImage("http://hazwx.com/img/icons/plus-full.png", new google.maps.Size(30, 30), new google.maps.Point(Math.floor(index / 4) * 30, (index % 4) * 30)));
        }
    }
    for (var siteName in radarSites) {
        var url = "http://feeds.allisonhouse.com/" + allisonHousePToken + "/Uspln.places?site=" + siteName;
        $.get(url, function (data) {
            var titleStart = data.indexOf('Title: ') + 7;
            var titleEnd = data.indexOf('\n', titleStart);
            var title = data.substr(titleStart, titleEnd - titleStart);
            if (data.indexOf('Icon: ') < 0) return; 
            var icons = data.substr(data.indexOf('Icon: ')).replace(/Icon: /g,'').split('\n')
                .map(function(c) {
                    var props = c.split(',');
                    return { lat: props[0], lon: props[1], mag: props[4], remarks: props[5] };
                });
            for (var a = 0; a < icons.length; a++) {
                if (!icons[a].lon)continue;
                var icon = icons[a];
                var marker = new google.maps.Marker({
                    position: new google.maps.LatLng(icon.lat, icon.lon),
                    map: null,
                    icon: lightningIconImages[16 - icon.mag],
                    title: "Event: " + title +
                    "\nMagnitude: " + icon.mag +
                    "\nRemarks: " + icon.remarks
                });

                //add event to that marker
                google.maps.event.addListener(marker, 'click', function (e) {
                    infoWindow.setContent("<div id='infoWindowContent'><b>" +
                        this.title.replace(/\n/g, '<BR><B>').replace(/:/g, ':</B>') +
                            //"<B>Event: " + lightning.event + "</B><BR>" +
                            //"<B>Time:</B> " + lightning.timestamp + " (UTC)<BR>" +
                            //"<B>Magnitude:</B> " + lightning.mag + "<BR>" +
                            //"<B>City:</B> " + lightning.city + ", " + lightning.state + "<BR>" +
                            //"<B>County:</B> " + lightning.county + "<BR>" +
                            //"<B>Source:</B> " + lightning.source + "<BR>" +
                            //"<B>Remarks:</B> " + lightning.remarks + "<BR>" +
                            "</div>");
                    infoWindow.setPosition(e.latLng);
                    infoWindow.open(map);
                });
                ahLightning.push(marker);

                //console.log(lightning); //show what just got pushed
            }
        }).done(function (e) {
            //console.log("getJSON complete for " + radarSiteNames[reportCounter]); //the radarSiteNames[i] is undefined.
            reportCounter++;
            if (reportCounter == Object.keys(radarSites).length) {
                doneWaiting();
                console.log("all finished, " + reportCounter + " sites loaded.");
                toggleLightning();
            }
        });
    }
}

function toggleLightning() {
    if (!ahLightning || !ahLightning[0]) return;
    if (ahLightning[0].getMap() == map) {   //markers already visible, remove them
        for (var i = 0; i < ahLightning.length; i++) {
            ahLightning[i].setMap(null);   //remove marker
            $("#preloadImagesBtn").prop("checked", false);
        }
    }
    else {  //remove the map
        for (i = 0; i < ahLightning.length; i++) {
            ahLightning[i].setMap(map);   //place marker on map
            $("#preloadImagesBtn").prop("checked", true);
        }
    }
}
