/// <reference path="~/vsdocs/google-maps-3-vs-1-0.js" />
/// <reference path="gMapFunctions.js" />
/// <reference path="ahCore.js" />
/// <reference path="../map/radarSites.js" />

var ahScitDownloadTime = new Date(0);
//create AllisonHouse Storm Report object (arrays will be stored within as properties)
var ahScits = [];
var radarCoordinates = {};

$(function () {
    $(".ahScitToggle").change(function () {
        checkReportDownloadTime(this.getAttribute("data-reporttype"), $(this), toggleScits, downloadAHScit);
        requestedScit = this.getAttribute("data-reporttype");
    });
});



function downloadAHScit() {
    waitForIt();
    console.log("Starting fetch of AH Scit...");
    ahScitDownloadTime = new Date(); //record our time
    var reportCounter = 0;
    ahScits = []; //array for all the storm report markers

    for (var siteName in radarSites) {
        var url = "http://feeds.allisonhouse.com/" + allisonHousePToken + "/Scit.json?site=" + siteName;

        $.ajax({
            url: url,
            async: false,
            dataType: "JSON",
            success: function (data) {
                if (!data.scits || !data.scits.radla) return;
                radarCoordinates[siteName] = { lat: data.scits.radla, lng: data.scits.radlo };
            var marker = new google.maps.Marker({
                position: new google.maps.LatLng(data.scits.radla, data.scits.radlo)
            });
            ahScits.push(marker);
            for (var s = 0; s <= data.scits.scit.length; s++) {
                //for (var b in data[a]) {
                var scit = data.scits.scit[s];
                    if(true || !scit) continue;
                    var polygon = new google.maps.Polygon({
                        paths: scit['boxes_cord'].outline.substr(outline.indexOf('\"AAA\"\n'), outline.indexOf('\nEnd:'))
                            .split('\n').map(function (c) {
                                return new google.maps.LatLng(c.split(',')[0], c.split(',')[1]);
                            }),
                        strokeColor: '#FFF',
                        strokeOpacity: 0.8,
                        strokeWeight: 1,
                        fillColor: 'gray',
                        fillOpacity: 0.1,
                        title: "Event: " + scit.type +
                            "\nExpire Time (UTC): " + scit.expire +
                            "\nRemarks: " + scit.disc.substr(0, 200)
                    });

                    //add phenom to that marker
                    google.maps.event.addListener(marker, 'click', function (e) {
                        infoWindow.setContent("<div id='infoWindowContent'><b>" +
                            this.title.replace(/\n/g, '<BR><B>').replace(/:/g, ':</B>') +
                            "</div>");
                        infoWindow.setPosition(e.latLng);
                        infoWindow.open(map);
                    });
                //}
            }
        }});
    }
    console.log("all finished, " + reportCounter + " sites loaded. Took " + (new Date() - ahScitDownloadTime) / 1000 + " secs");
    toggleScits(requestedScit);
    doneWaiting();
}

function toggleScits() {
    if (ahScits[0] && ahScits[0].getMap() == map) {   //markers already visible, remove them
        for (var i = 0; i < ahScits.length; i++) {
            ahScits[i].setMap(null);   //remove marker
            $("#preloadImagesBtn").prop("checked", false);
        }
    }
    else {  //remove the map
        for (i = 0; i < ahScits.length; i++) {
            ahScits[i].setMap(map);   //place marker on map
            $("#preloadImagesBtn").prop("checked", true);
        }
    }
}
