/// <reference path="~/vsdocs/google-maps-3-vs-1-0.js" />
/// <reference path="gMapFunctions.js" />
/// <reference path="ahCore.js" />
/// <reference path="../map/radarSites.js" />

var ahWarningDownloadTime = new Date(0);
//create AllisonHouse Storm Report object (arrays will be stored within as properties)
var ahWarnings = [];
var warningBoxColors = { 'Severe Thunderstorm Warning': '#FFA500', 'Tornado Warning': '#F00', 'TORNADO': '#F00', 'Flash Flood Warning': '#0F0' };
var requestedWarning = null;

$(function () {
    $(".ahWarningToggle").change(function () {
        checkReportDownloadTime(this.getAttribute("data-reporttype"), $(this), ahWarningDownloadTime, toggleWarnings, downloadAHWarning);
    });
});

function downloadAHWarning() {
    waitForIt();
    console.log("Starting fetch of AH Reports...");
    ahWarningDownloadTime = new Date(); //record our time
    var reportCounter = 0;
    ahWarnings = []; //array for all the storm report markers
    //var phenoms = Object.keys(ahPhenoms[requestedWarning]).map(function (c) { return "phenom[]=" + c; }).join('&');

    for (var siteName in radarSites) {
        var url = "http://feeds.allisonhouse.com/" + allisonHousePToken + "/Ww.json?site=" + siteName;

        $.getJSON(url, function (data) {
    //var data = JSON.parse('{"warnings": [{"filename": "201403122315.SVR","Action": "NEW","LastModified": "2014-03-12 23:25:48","UGC": "dec001","Office": "KPHI","WatchNumber": "0006","phenom": "SV","sig": "W","class": "O","EnglishProdType": "Severe Thunderstorm Warning","ProdTime": "2014-03-12 23:15:00","VTEC_Start": "2014-03-12 23:15:00","VTEC_End": "2014-03-13 00:00:00","ExpirationTime": "2014-03-13 00:00:00",' +
    //    '"contents": "999\\nWUUS51 KPHI 122315\\nSVRPHI\\nDEC001-003-MDC011-015-029-035-041-130000-\\n/O.NEW.KPHI.SV.W.0006.140312T2315Z-140313T0000Z/\\n\\nBULLETIN - EAS ACTIVATION REQUESTED\\nSEVERE THUNDERSTORM WARNING\\nNATIONAL WEATHER SERVICE MOUNT HOLLY NJ\\n715 PM EDT WED MAR 12 2014\\n\\nTHE NATIONAL WEATHER SERVICE IN MOUNT HOLLY NJ HAS ISSUED A\\n\\n* SEVERE THUNDERSTORM WARNING FOR...\\n  SOUTHERN NEW CASTLE COUNTY IN NORTHERN DELAWARE...\\n  SOUTHEASTERN CECIL COUNTY IN NORTHEAST MARYLAND...\\n  KENT COUNTY IN NORTHEAST MARYLAND...\\n  NORTHWESTERN KENT COUNTY IN CENTRAL DELAWARE...\\n  CAROLINE COUNTY IN EASTERN MARYLAND...\\n  QUEEN ANNES COUNTY IN NORTHEAST MARYLAND...\\n  TALBOT COUNTY IN EASTERN MARYLAND...\\n\\n* UNTIL 800 PM EDT\\n\\n* AT 713 PM EDT...NATIONAL WEATHER SERVICE DOPPLER RADAR INDICATED A\\n  LINE OF INCREASINGLY STRONGER AND BECOMING SEVERE THUNDERSTORMS. \\n  THESE STORMS EXTENDED FROM BETTERTON TO ROCK HALL TO DARES BEACH...\\n  MOVING EAST AT 40 MPH. THESE STORMS ARE CAPABLE OF PRODUCING \\n  DAMAGING WINDS IN EXCESS OF 60 MPH. \\n\\n* SEVERE THUNDERSTORMS WILL BE NEAR...\\n  HOLLYWOOD BEACH AND ROMANCOKE AROUND 720 PM EDT...\\n  CAYOTS AND GRASONVILLE AROUND 725 PM EDT...\\n  GRASONVILLE AND ST. MICHAELS AROUND 730 PM EDT...\\n  WARWICK AND MASSEY AROUND 735 PM EDT...\\n  MIDDLETOWN AND MILLINGTON AROUND 740 PM EDT...\\n  EASTON AND SUDLERSVILLE AROUND 745 PM EDT...\\n\\nPRECAUTIONARY/PREPAREDNESS ACTIONS...\\n\\nTHIS SEVERE THUNDERSTORM MAY CONTAIN LITTLE OR NO LIGHTNING. DO NOT\\nWAIT TO HEAR THUNDER BEFORE TAKING COVER. SEEK SHELTER IMMEDIATELY\\nINSIDE A STURDY STRUCTURE AND STAY AWAY FROM WINDOWS.\\n\\nA SEVERE THUNDERSTORM WATCH REMAINS IN EFFECT UNTIL 1000 PM EDT\\nWEDNESDAY EVENING FOR DELAWARE AND NORTHEASTERN MARYLAND AND SOUTHERN\\nNEW JERSEY.\\n\\n&&' +
    //    '\\n\\nLAT...LON 3887 7625 3881 7621 3882 7620 3894 7624 3884 7638 3886 7639 3904 7631 3899 7627 3900 7618 3914 7629 3932 7619 3943 7601 3952 7599 3945 7556 3941 7552 3860 7598 3859 7612 3873 7626 3867 7635 3877 7639\\nTIME...MOT...LOC 2315Z 284DEG 33KT 3943 7600 3919 7626     3865 7647\\n\\n$$\\n"}],"id": null}');
            if (!data.warnings || data.warnings.length == 0)return;
            for (var a = 0; a < data.warnings.length; a++) {
                var warning = data.warnings[a];
                var outlinesStart = warning.contents.indexOf('\nLAT...LON') + 11;
                var outlinesEnd = warning.contents.indexOf('\nTIME...', outlinesStart);
                if (outlinesEnd < 0) outlinesEnd = warning.contents.indexOf('\n$$', outlinesStart);
                var outlines = warning.contents.substr(outlinesStart, outlinesEnd - outlinesStart).replace(/\s{2,}/g, ' ').split(' ')
                .map(function (cur) { return cur.trim(); });
                var outline = [];
                for (var c = 0; c < outlines.length; c++) {
                    if (c % 2 == 0)
                        outline.push(new google.maps.LatLng(parseInt(outlines[c]) * .01, parseInt(outlines[c + 1]) * -.01));
                }
                var polygon = new google.maps.Polygon({
                    paths: outline,
                    strokeColor: warningBoxColors[warning.EnglishProdType],
                    strokeOpacity: 1,
                    strokeWeight: 2,
                    fillColor: warningBoxColors[warning.EnglishProdType],
                    fillOpacity: 0,
                    title: "Event: " + warning.EnglishProdType +
                        "\nExpire Time (UTC): " + warning.ExpirationTime +
                        "\nRemarks: " + warning.contents.substr(0, 200)
                });
                var polyline = new google.maps.Polyline({
                    path: outline,
                    geodesic: true,
                    strokeColor: warningBoxColors[warning.EnglishProdType],
                    strokeOpacity: 1,
                    strokeWeight: 1,
                });

                //add phenom to that marker
                google.maps.event.addListener(polygon, 'click', function(e) {
                    infoWindow.setContent("<div id='infoWindowContent'><b>" +
                        this.title.replace(/\n/g, '<BR><B>').replace(/:/g, ':</B>') +
                        //"<B>Event: " + warning.phenom + "</B><BR>" +
                        //"<B>Time:</B> " + warning.timestamp + " (UTC)<BR>" +
                        //"<B>Magnitude:</B> " + warning.mag + "<BR>" +
                        //"<B>City:</B> " + warning.city + ", " + warning.state + "<BR>" +
                        //"<B>County:</B> " + warning.county + "<BR>" +
                        //"<B>Source:</B> " + warning.source + "<BR>" +
                        //"<B>Remarks:</B> " + warning.remarks + "<BR>" +
                        "</div>");
                    infoWindow.setPosition(e.latLng);
                    infoWindow.open(map);
                });
                warning.polygon = polygon;
                ahWarnings.push({ polygon: polygon, polyline: polyline });
                //for (var category in ahPhenoms) {
                //    if (ahPhenoms[category].hasOwnProperty(warning.phenom)) {
                //        ahWarnings[category].push(polygon);
                //        break;
                //    }
                //}
                //console.log(warning.phenom); //show what just got pushed
                //doneWaiting();
                //toggleWarnings();
            }
        }).done(function () {
            //console.log("getJSON complete for " + radarSiteNames[reportCounter]);
            reportCounter++;
            if (reportCounter == Object.keys(radarSites).length) {
                doneWaiting();
                console.log("all finished, " + reportCounter + " sites loaded. Took " + (new Date() - ahWarningDownloadTime) / 1000 + " secs");
                toggleWarnings(requestedWarning);
            }
        });
    }
}

function toggleWarnings() {
    if (!ahWarnings || !ahWarnings[0]) return;
    if (ahWarnings[0].polygon.getMap() == map) {   //markers already visible, remove them
        for (var i = 0; i < ahWarnings.length; i++) {
            ahWarnings[i].polygon.setMap(null);   //remove marker
            ahWarnings[i].polyline.setMap(null);   //remove marker
            $("#preloadImagesBtn").prop("checked", false);
        }
    }
    else {  //remove the map
        for (i = 0; i < ahWarnings.length; i++) {
            ahWarnings[i].polygon.setMap(map);   //place marker on map
            ahWarnings[i].polyline.setMap(map);   //place marker on map
            $("#preloadImagesBtn").prop("checked", true);
        }
    }
}
