/// <reference path="~/vsdocs/google-maps-3-vs-1-0.js" />
/// <reference path="gMapFunctions.js" />
/// <reference path="ahCore.js" />
/// <reference path="../map/radarSites.js" />

var ahWatchBoxDownloadTime = new Date(0);
//create AllisonHouse Storm Report object (arrays will be stored within as properties)
var ahWatchBoxes = [];
var watchBoxColors = { 'SEVERE THUNDERSTORM': '#00F', 'TORNADO': '#F00' };
var requestedWatchBox = null;

$(function () {
    $(".ahWatchBoxToggle").change(function () {
        checkReportDownloadTime(this.getAttribute("data-reporttype"), $(this), ahWatchBoxDownloadTime, toggleWatchBoxes, downloadAHWatchBox);
    });
});



function downloadAHWatchBox() {
    waitForIt();
    console.log("Starting fetch of AH Reports...");
    ahWatchBoxDownloadTime = new Date(); //record our time
    var reportCounter = 0;
    ahWatchBoxes = []; //array for all the storm report markers
    //var phenoms = Object.keys(ahPhenoms[requestedWatchBox]).map(function (c) { return "phenom[]=" + c; }).join('&');

    for (var siteName in radarSites) {
        var url = "http://feeds.allisonhouse.com/" + allisonHousePToken + "/Boxes.json?site=" + siteName;

        $.getJSON(url, function (data) {
            for (var a in data) {
                for (var b in data[a]) {
                    var watchBox = data[a][b];
                    var outline = watchBox['boxes_cord'].outline;
                    var polygon = new google.maps.Polygon({
                        paths: watchBox['boxes_cord'].outline.substr(outline.indexOf('\"AAA\"\n'), outline.indexOf('\nEnd:'))
                            .split('\n').map(function (c) {
                            return new google.maps.LatLng(c.split(',')[0], c.split(',')[1]);
                        }),
                        strokeColor: watchBoxColors[watchBox.type],
                        strokeOpacity: 0.1,
                        strokeWeight: 1,
                        fillColor: watchBoxColors[watchBox.type],
                        fillOpacity: 0.0,
                        title: "Event: " + watchBox.type +
                            "\nExpire Time (UTC): " + watchBox.expire +
                            "\nRemarks: " + watchBox.disc.substr(0, 200)
                    });

                    //add phenom to that marker
                    google.maps.event.addListener(polygon, 'click', function(e) {
                        infoWindow.setContent("<div id='infoWindowContent'><b>" +
                            this.title.replace(/\n/g, '<BR><B>').replace(/:/g, ':</B>') +
                            //"<B>Event: " + watchBox.phenom + "</B><BR>" +
                            //"<B>Time:</B> " + watchBox.timestamp + " (UTC)<BR>" +
                            //"<B>Magnitude:</B> " + watchBox.mag + "<BR>" +
                            //"<B>City:</B> " + watchBox.city + ", " + watchBox.state + "<BR>" +
                            //"<B>County:</B> " + watchBox.county + "<BR>" +
                            //"<B>Source:</B> " + watchBox.source + "<BR>" +
                            //"<B>Remarks:</B> " + watchBox.remarks + "<BR>" +
                            "</div>");
                        infoWindow.setPosition(e.latLng);
                        infoWindow.open(map);
                    });
                    watchBox.polygon = polygon;
                    ahWatchBoxes.push(polygon);
                    //for (var category in ahPhenoms) {
                    //    if (ahPhenoms[category].hasOwnProperty(watchBox.phenom)) {
                    //        ahWatchBoxes[category].push(polygon);
                    //        break;
                    //    }
                    //}
                    //console.log(watchBox.phenom); //show what just got pushed
                }
            }
        }).done(function () {
            //console.log("getJSON complete for " + radarSiteNames[reportCounter]);
            reportCounter++;
            if (reportCounter == Object.keys(radarSites).length) {
                doneWaiting();
                console.log("all finished, " + reportCounter + " sites loaded. Took " + (new Date() - ahWatchBoxDownloadTime) / 1000 + " secs");
                toggleWatchBoxes(requestedWatchBox);
            }
        });
    }
}

function toggleWatchBoxes() {
    if (!ahWatchBoxes || !ahWatchBoxes[0]) return;
    if (ahWatchBoxes[0].getMap() == map) {   //markers already visible, remove them
        for (var i = 0; i < ahWatchBoxes.length; i++) {
            ahWatchBoxes[i].setMap(null);   //remove marker
            $("#preloadImagesBtn").prop("checked", false);
        }
    }
    else {  //remove the map
        for (i = 0; i < ahWatchBoxes.length; i++) {
            ahWatchBoxes[i].setMap(map);   //place marker on map
            $("#preloadImagesBtn").prop("checked", true);
        }
    }
}
