function setLoginText() {
    document.getElementById('loginText').innerHTML = document.getElementById('hazwxs').value;
}

function launchFeedback() {
    console.log("Launching Feedback and FAQ window. If you don\'t see it, please enable popups.");
    ga('send', 'event', 'faqbutton', 'click');
    window.open("http://hazwx.com/map-faq", "ContactWindow", "scrollbars=1,status=0,toolbar=0,location=0,menubar=0,directories=0,resizable=0,height=500,width=400");
}

function makeShortDate(dateObj, utc) {
    console.log("Converting Date Object " + dateObj);
    var friendlyString = "";
    var trailingZero = "";
    if (utc) {
        if (dateObj.getUTCMinutes() == 0) {
            trailingZero = "0";
        }
        friendlyString = getDayOfWeek(dateObj, true) + " " + dateObj.getUTCDate() + " " + getMonthName(dateObj, true) + " @ " + dateObj.getUTCHours() + ":" + dateObj.getUTCMinutes() + trailingZero + "z";
    }
    else {
        friendlyString = getDayOfWeek(dateObj, false) + " " + dateObj.getDate() + " " + getMonthName(dateObj, false) + " @ " + getFriendlyTime(dateObj);
    }
    return friendlyString;
}

function getDayOfWeek(date, utc) {
    console.log("Getting day name for Date Object " + date + " (UTC: " + utc + ")");
    //returns the friendly day string
    //use utc=true for UTC time
    var days = new Array();
    var dayName;
    days[0] = "Sun";
    days[1] = "Mon";
    days[2] = "Tue";
    days[3] = "Wed";
    days[4] = "Thu";
    days[5] = "Fri";
    days[6] = "Sat";
    if (utc) {
        dayName = days[date.getUTCDay()];
    }
    else {
        dayName = days[date.getDay()];
    }
    return dayName;
}

function makeDate(ugly) {
    console.log("Converting " + ugly + " into a dateObject");
    //given a sql date string (YYYYMMDDHH), return a date object
    //separate out the ugly string
    var uYear = ugly.substr(0, 4);
    var uMonth = ugly.substr(4, 2) - 1;    //month is 0-indexed
    var uDay = ugly.substr(6, 2);
    var uHour = ugly.substr(8, 2);

    //get UTC milliseconds for this datetime: (M/S/ms all assumed zero)
    var utcDateMS = Date.UTC(uYear, uMonth, uDay, uHour);

    //create a date object from those milliseconds:
    var dateObject = new Date(utcDateMS);
    return dateObject;
}

function getFriendlyTime(date) {
    console.log("Converting hours for " + date + " to local time format");
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var dd = "am";
    var h = hours;
    if (h >= 12) {
        h = hours - 12;
        dd = "pm";
    }
    if (h == 0) { h = 12 }

    if (h < 10) { h = "" + h; }
    if (minutes < 10) { minutes = "0" + minutes; }
    var friendlyTime = h + ":" + minutes + dd;
    return friendlyTime;
}

function getFriendlyHours(date) {
    console.log("Converting hours for " + date + " to local time");
    var friendlyHourString = "";
    var dd = "am";
    var hh = date.getHours();
    var mm = date.getMinutes();
    var h = hh;
    if (h >= 12) {
        h = hh - 12;
        dd = "pm";
    }
    if (h == 0) {
        h = 12;
    }

    friendlyHourString = h + dd; //+ " " + String(String(date).split("(")[1]).split(")")[0];
    return friendlyHourString;
}

function getMonthName(date, utc) {
    console.log("Converting month name for Date Object " + date + " (UTC: " + utc + ")");
    //returns the friendly month string
    //use utc=true for UTC time
    var month = new Array();
    var monthName;
    month[0] = "Jan";
    month[1] = "Feb";
    month[2] = "Mar";
    month[3] = "Apr";
    month[4] = "May";
    month[5] = "Jun";
    month[6] = "Jul";
    month[7] = "Aug";
    month[8] = "Sep";
    month[9] = "Oct";
    month[10] = "Nov";
    month[11] = "Dec";
    if (utc) {
        monthName = month[date.getUTCMonth()];
    }
    else {
        monthName = month[date.getMonth()];
    }
    return monthName;
}

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results == null ? null : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function getCookie(cName) {
    if (navigator.cookieEnabled && document.cookie.length > 0 && !window.device) {
        var name = cName + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i].trim();
            if (c.indexOf(name) == 0) return unescape(c.substring(name.length, c.length));
        }
    } else if (typeof localStorage != "undefined") {
        return localStorage[cName];
    }
    return "";
}

function setCookie(cName, value, expiredays) {
    var exdate = new Date();
    exdate.setDate(exdate.getDate() + expiredays);
    document.cookie = 'test';
    if (navigator.cookieEnabled && document.cookie.length > 0 && !window.device) {
        console.log("Saving preferences to cookie");
        document.cookie = cName + "=" + escape(value) +
        ((expiredays === null) ? "" : ";expires=" + exdate.toUTCString());
    } else if (typeof localStorage != "undefined") {
        console.log("Saving preferences to local storage");
        localStorage[cName] = value;
    }
}

function getSQLTimeString(d) {
    console.log("Creating a SQL-style date-time string from " + d);
    //given date object d, return SQL string formatted YYYYMMDDHHMM
    var year = d.getFullYear();
    var month = ("0" + d.getMonth() + 1).slice(-2);
    var day = ("0" + d.getDate()).slice(-2);
    var hour = ("0" + d.getHours()).slice(-2);
    var min = ("0" + d.getMinutes()).slice(-2);
    var sec = ("0" + d.getSeconds()).slice(-2);
    return year + month + day + hour + min;
}

function wireUpLabels(container, callback) {
    var radioLabels = container.getElementsByTagName('label');
    var radioInputs = container.getElementsByTagName('input');
    for (var i = 0; i < radioLabels.length; i++) {
        radioLabels[i].addEventListener('click', callback);
        radioInputs[i].addEventListener('change', callback);
    }
}

if (!String.format) {
    String.format = function (format) {

        var args = Array.prototype.slice.call(arguments, 1);
        var sprintfRegex = /\{(\d+)\}/g;

        var sprintf = function (match, number) {
            return number in args ? args[number] : match;
        };

        return format.replace(sprintfRegex, sprintf);
    };
}

function shortenURL(longUrl, callback) {
    console.log("Shortening a long URL...");
    var url = "http://api.hazardnotifications.com/shorten_url/";

    $.getJSON(url, {
        long_url: longUrl,
        user_id: wordpressUserIdNumber,
        user_pass: wordpressUserHash
    }, function (data) {
        console.log("HN API call success: " + data.success);

        if (data.success != true) {             //API returned false, find out why
            alert("There was an error shortening this URL. Please try again later or contact us if this issue persists.");
            return false;
        }

        else {
            var shareUrl = "http://hazwx.com/share/#" + data.short_link_id;
            if (callback)
                callback(shareUrl);
            return shareUrl;
        }
    });
}

function getJSON(url, data, callback) {
    ajaxCall(url, 'GET', data, 'json', callback);
}

function ajaxGet(url, data, callback) {
    ajaxCall(url, 'GET', data, null, callback);
}

function ajaxPost(url, data, callback) {
    ajaxCall(url, 'GET', data, null, callback);
}

function ajaxCall(url, type, data, dataType, callback) {
    $.ajax(url, {
        type: type,
        data: data,
        dataType: dataType
    }).done(callback)
        .fail(function (jqXhr, textStatus, errorThrown) {
            alert(jqXhr.statusCode() + ' ' + errorThrown);
        });
}