﻿/// <reference path="~/www/phonegap.js" />
/// <reference path="~/vsdocs/google-maps-3-vs-1-0.js" />
/// <reference path="~/www/js/gMapCore.js" />
/// <reference path="~/www/js/gMapUI.js" />
/// <reference path="~/www/js/gMapFunctions.js" />
/// <reference path="~/www/js/longpress.js" />
$(function() {
    document.addEventListener("deviceready", onDeviceReady, false);
    document.addEventListener("mapinitialized", mapInitialized, false);
    function onDeviceReady() {
        document.addEventListener("pause", savePreferences, false);
        document.addEventListener("resume", reloadSavedView, false);
    }

    function openInAppBrowser(e) {
        e.preventDefault();
        console.log('opening external link');
        var url = this.href.replace(/file\:|x-wmapp0\:/, '');
        if (url[url.length - 1] === '#') return false;
        if (url.indexOf('http') !== 0) url = 'http://hazwx.com/' + url;
        navigator.notification.confirm('Leave HazWx app?', function(i) {
            if (i === 1) window.open(encodeURI(url), '_system', 'location=no');
        }, 'HazWx');
    }

    function mapInitialized() {
        var aTags = document.getElementsByTagName('a');
        for (var i = 0; i < aTags.length; i++) {
            aTags[i].onclick =  openInAppBrowser;
        }
        setLoginText();
        map.set('minZoom', 3);
        map2.set('minZoom', 3);
        var map1LongPress = new LongPress(map, 1500);
        var map2LongPress = new LongPress(map2, 1500);

        google.maps.event.addListener(map, 'longpress', function (event) {
            placeSounding(event.latLng, map);           //in soundings.js
        });
        google.maps.event.addListener(map2, 'longpress', function (event) {
            placeSounding(event.latLng, map2);           //in soundings.js
        });
    }

    function setLoginText() {
        var loginTextDiv = document.getElementById('loginText');
        if (wordpressUserIdNumber && wordpressUserHash) {
            loginTextDiv.innerHTML = '<a id="myAccount" href="http://hazwx.com/account" class="">My Account</a> | <a id="logout" href="http://hazwx.com/logout/" class="">Logout</a>';
            document.getElementById('logout').onclick = logoutWp;
            document.getElementById('myAccount').onclick = openInAppBrowser;
        } else {
            loginTextDiv.innerHTML =
                '<p>Welcome Visitor! Please enjoy this limited free preview (start with Model Selection below). Like what you see? Why not subscribe?</p>' +
                '<form id="login" action="login" method="post">' +
                '<h3>HazWx Login</h3>' +
                '<p class="status"></p>' +
                '<label for="username">Username</label>' +
                '<input id="username" type="text" name="username">' +
                '<label for="password">Password</label>' +
                '<input id="password" type="password" name="password">' +
                '<input id="loginButton" class="submit_button" type="submit" value="Login" name="submit">' +
                '<input id="signupButton" type="button" data-url="http://hazwx.com/subscriptions" value="Signup" />' +
                '<br/><a id="lostPasswordLink" class="lost" href="http://hazwx.com/lostpassword">Lost your password?</a>' +
                '</form>';
            document.getElementById('loginButton').onclick = function (e) {
                e.preventDefault();
                waitForIt();
                var formData = $(this).parent('form').serialize();
                $.get('https://api.hazardnotifications.com/get_user_pass_hash/',
                    formData, function (data) {
                        if (data && data.success) {
                            wordpressUserIdNumber = data.user_id;
                            wordpressUserHash = data.user_pass;
                            setCookie('HazWx_WP_User', JSON.stringify({ userId: wordpressUserIdNumber, userHash: wordpressUserHash }));
                            refreshUserContent();
                        } else {
                            alert('Invalid login.');
                        }
                    doneWaiting();
                });
            };
            document.getElementById('signupButton').onclick = function(e) {
                window.open(encodeURI(this.getAttribute('data-url')), '_system', 'location=yes');
            };
            document.getElementById('lostPasswordLink').onclick = openInAppBrowser;
        }

    }

    function logoutWp(e) {
        e.preventDefault();
        wordpressUserIdNumber = null;
        wordpressUserHash = null;
        setCookie('HazWx_WP_User', '', new Date(0));
        refreshUserContent();
    }

    function refreshUserContent() {
        setLoginText();
        getModels();
        getLogo(wordpressUserIdNumber, wordpressUserHash);
    }
});