var wordpressUserIdNumber = "", wordpressUserHash = "";

$(function () {
    document.getElementById('openControlPanelButton').addEventListener('click', toggleControlPanel, false);
    document.getElementById('closeControlPanelButton').addEventListener('click', toggleControlPanel, false);
});

function toggleControlPanel() {
    var toggleButton = document.getElementById("openControlPanelButton");
    var sidebar = document.getElementById("controlPanel");
    var sidebarStyle = window.getComputedStyle(sidebar);
    if (sidebarStyle.getPropertyValue('overflow-y') != "hidden") {
        toggleButton.className = toggleButton.className.replace(/expanded/g, '');
        toggleButton.className += " collapsed";
    } else {
        toggleButton.className = toggleButton.className.replace(/collapsed/g, '');
        toggleButton.className += " expanded";
    }
}

function hideElement(element) {
    document.getElementById(element).style.display = 'none';
}

function goToPanel(panelNumber) {
    console.log("Opening panel " + panelNumber);
    $('#accordion').accordion('option', 'active', panelNumber);
}

function getLogo(user, hash) {
    console.log("Querying for a logo on user #" + user + "\'s account...");
    var url = "http://api.hazardnotifications.com/get_user_logo/?user_id=" + wordpressUserIdNumber + "&user_pass=" + wordpressUserHash;
    $.getJSON(url, function (data) {
        var logoUrl = data.logo_url;
        var succeed = data.success;
        if (logoUrl != null && succeed != false) {      //only process this if the call completes and the user has a logo
            console.log("User has a custom logo from " + logoUrl);
            document.getElementById("logoBug").className = "logoCustom";
            document.getElementById("logoImg").src = logoUrl;
            document.getElementById("logoImg").style.display = "block";
            document.getElementById("logoDefault").style.display = "none";
        }

        if (succeed == true) {
            console.log("User is media customer, access to set-logo-button is granted.");
            document.getElementById("logoFormDiv").style.display = "block";      //display the form for image URL setting
            //document.getElementById("logoInput").value = logoURL;
        }

        if (logoUrl == null && succeed != false) {
            console.log("User has no logo set, displaying default logo instead.");
            $('#logoBug').removeClass('logoCustom');
            document.getElementById("logoImg").style.display = "none";
            document.getElementById("logoDefault").style.display = "block";
        }
    });
}

function changeLogo() {
    console.log("Prompting for new logo URL...");
    var newLogoUrl = null, currentLogo;
    while (!newLogoUrl) {
        if (document.getElementById("logoImg").style.display == "block") {
            currentLogo = document.getElementById("logoImg").src;
        }
        else {
            currentLogo = "";
        }
        newLogoUrl = prompt("Enter the URL for your logo image. We recommend an alpha-transparent PNG image of 300x65 pixels. Leave the box empty to remove your current logo.", currentLogo);
        if (newLogoUrl === null || newLogoUrl === false) { // Cancelled
            console.log("New logo input cancelled, no action taken.");
            break; // Leave this out, if the newLogoURL is mandatory
        }
        if (newLogoUrl === "") { // OK, but no newLogoURL
            console.log("Setting new logo to null with clear parameter.");
            sendNewLogo("clear");
            break;
        } else { // OK with a name
            console.log("Setting new logo to " + newLogoUrl);
            sendNewLogo(newLogoUrl);
        }
    }
}

function sendNewLogo(logoParam) {
    var theUrl = "http://api.hazardnotifications.com/update_media_logo/?user_id=" + wordpressUserIdNumber + "&user_pass=" + wordpressUserHash + "&logo_url=" + logoParam;
    console.log("Passing new logo to URL: " + theUrl);
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open("GET", theUrl, false);
    xmlHttp.send(null);
    getLogo(wordpressUserIdNumber, wordpressUserHash);
    console.log("Update Media Logo resulted in " + xmlHttp.responseText);
    return xmlHttp.responseText;
}