var feedback = getURLValue("feedback");
var wait = getURLValue("wait");
var soundingImg = getURLValue("img");
var model = getURLValue("model");
var init = getURLValue("init");
var fhour = getURLValue("fhour");
var valid = getURLValue("valid").replace(/@/g, "at");
var lat = getURLValue("lat");
var lon = getURLValue("lon");
var wordpressUserId = document.getElementById("hazwxu").value;
var wordpressUserHash = document.getElementById("hazwxh").value;
document.title = "Generating sounding...";

function populate() {
    console.log("Beginning sounding...");

    if (getURLValue("feedback")) {
        document.getElementById('message').textContent = feedback;	//display feedback
        document.getElementById('throbber').src = "";								//remove throbber
        document.title = "Failure | Sounding Viewer";								//set title
        return false;
    }

    //draw the overlay map
    var overviewMapSrc = "http://maps.googleapis.com/maps/api/staticmap?zoom=5&size=380x320&maptype=roadmap&sensor=false&markers=color:red%7C";
    overviewMapSrc = overviewMapSrc + lat + ", " + lon;
    document.getElementById('locationOverviewMap').src = overviewMapSrc;

    if (getURLValue("img")) {
        //image found, use it
        document.getElementById('soundingImage').src = soundingImg;
        document.title = "Sounding Viewer";
        document.getElementById('throbber').src = "";
        setTimeout("document.getElementById('message').textContent = 'Image no longer exists.';", 2000);
        document.getElementById('social').style.display = "block";
    }

    if (getURLValue("wait") == 1) {
        getSounding();
    }
}

function getSounding() {
    console.log("Asking for sounding image for this location...");
    var url = "http://api.hazardnotifications.com/get_sounding/";

    $.getJSON(url, {
        model_name: model,
        model_init_datetime: init,                           //"2014022215"
        forecast_hour: fhour,                            //"15"
        valid_time: valid,              //"Sat_22_Feb_@_21z"
        lat: lat,
        lon: lon,
        user_id: wordpressUserId,
        user_pass: wordpressUserHash
    }, function (data) {
        console.log("HN API call success: " + data.success);

        if (data.success != true) {             //API returned false, find out why
            window.location = "sounding.html?feedback=" + data.reason + "&lat=" + lat + "&lon=" + lon;
            return false;
        }

        else {
            window.location = "sounding.html?img=" + data.skewt_url + "&lat=" + lat + "&lon=" + lon + "&model=" + model + "&fhour=" + fhour + "&valid=" + valid;
            //ga('button', 'event', 'sounding', 'click');
        }
    });
}

function getURLValue(name) {
    name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
    var regexS = "[\\?&]" + name + "=([^&#]*)";
    var regex = new RegExp(regexS);
    var results = regex.exec(window.location.search);
    if (results == null)
        return "";
    else
        var paramValue = decodeURIComponent(results[1].replace(/\+/g, " "));
    return paramValue;
}

function shareToFacebook() {
    var currentURL = top.location.href;
    var fbShareUrl = "https://www.facebook.com/dialog/feed?app_id=798871373463660&display=popup&link=" + encodeURIComponent(currentURL) + "&redirect_uri=http://hazwx.com/thanks&picture=" + soundingImg +
        "&name=" + model + " - valid " + getURLValue("valid").replace(/_/g, " ") + "&caption=Sounding Viewer&description=Point Forecast Soundings provided by HazWx.com.";
    window.open(fbShareUrl, '_system', 'location=no,menubar=no,status=no,toolbar=no,titlebar=no,height=360,width=680');
}

function shareToTwitter() {
    //recommended size from twitter is 550x420
    //image resources: https://dev.twitter.com/docs/image-resources
    twShareUrl = "https://twitter.com/intent/tweet?via=haznotification&text=" + model + " sounding from HazWx.com&url=http://hazwx.com/maps/?share=" + top.location;
    window.open(encodeURI(twShareUrl), '_system', 'location=no,menubar=no,status=no,toolbar=no,titlebar=no,height=420,width=550');
}

function shareToGoogle() {
    //image resources: https://developers.google.com/+/web/share/
    goShareUrl = "https://plus.google.com/share?url=http://hazwx.com/maps/?share=" + top.location;
    window.open(encodeURI(goShareUrl), '_system', 'location=no,menubar=no,status=no,toolbar=no,titlebar=no,height=420,width=550');
}