var viewerWindow;
var soundingMarker = new google.maps.Marker({
    title: 'Sounding Generation Location (click to hide pin)'
});

google.maps.event.addListener(soundingMarker, "click", function () {
    soundingMarker.setMap(null);
});


function placeSounding(position, map, target) {
    var lat = Math.round(position.lat() * 1000) / 1000;
    var lon = Math.round(position.lng() * 1000) / 1000;
    var pinSpot = new google.maps.LatLng(lat, lon);

    if (wordpressUserIdNumber <= 0) {
        alert("Login to enable right-click soundings.");
        return false;
    }

    if (currentDisplayedHour < 0) {
        alert("Load a forecast model to enable right-click soundings.");
        return false;
    }

    if (displayedModelName == "RTMA") {
        alert("Right-click point soundings are not available for Real-Time Mesoscale Analysis Product.\n\nChoose a forecast product instead to enable point soundings.");
        return false;
    }

    if (displayedModelName == "NAM 4KM" || displayedModelName == "HRRR") {
        alert("Due to the high-resolution of the " + displayedModelName + " model, we are still working on testing the data. We hope to have soundings for this model soon.\n\nChoose another forecast product instead to enable point soundings.");
        return false;
    }

    if (displayedModelName == "HazWrf" || displayedModelName == "BAM WRF 2km" || displayedModelName == "HazEuro") {
        alert("Sorry, soundings for this model are still in development and are not available yet.");
        return false;
    }

    if (viewerWindow) {     //if viewer window is open, close it
        viewerWindow.close();
    }

    var soundingViewerUrl = "/sounding/?wait=1" +
        "&model=" + displayedModelName +
        "&init=" + initDateTimeSql +
        "&fhour=" + currentDisplayedHour +
        "&valid=" + displayedValidHour.replace(/ /g, "_") +
        "&lat=" + lat + "&lon=" + lon;

    viewerWindow = window.open(soundingViewerUrl, "soundingViewer", "width=1085, height=720, resizable=1", false);     //open viewer window

    soundingMarker.setPosition(pinSpot);
    //soundingMarker.setMap(map);


    if (!viewerWindow) {        //make sure it got opened
        alert("We tried to open a popup window but got blocked. Can you check your popup blocker?");
        return false;
    }
}